#ifndef __auto_h
#define __auto_h
#include <fstream>
#include "sutartis.h"
class Auto {
   private:
      std::string marke;
      bool busena;
      std::list<Sutartis*> sutartis;
   public:
      Auto(std::string marke, bool busena);
      ~Auto();
      std::string getAuto();
      bool getBusena();
      bool setBusena();
      bool unsetBusena();
      void printAuto();
      int printVisaPelna();
      int printAutoPelnas(std::string nuo, std::string iki);
      void iSarasa(int pinigai, std::string date);
      void autoToFile(std::ofstream& outFile);
};

class Palyginti {
   public:
      bool operator() (Auto* a, Auto* b) {
         return (a->getAuto() < b->getAuto());
      }
};
#endif
