#include <iostream>
#include <fstream>
#include <string>
#include <list>
#include "skraidApar.h"

using namespace std;

typedef list<SkraidApar*>  SkraidAparList;


void  printSkraidAparList       (SkraidAparList&   skraidAparList);
SkraidApar* selectSkraidApar    (SkraidAparList&   skraidAparList);
void  skrydis                   (SkraidAparList&   skraidAparList);
void  newSkraidApar             (SkraidAparList&   skraidAparList);
void  printAparatuDetails       (SkraidAparList&   skraidAparList);

//-----------------------------------------------------------------
int main ()
{
	SkraidAparList  skraidAparList;

	//----------------------
    ifstream inFile ("plane.txt");
 	string  name;
 	int weightOfAparatus;
 	int weightOfPasenger;
 	int loadWeight;
 	int height;
 	int maxSpeed;
    inFile >> name;
    while (inFile.good())
     {			inFile >> weightOfAparatus;
 				inFile >> weightOfPasenger;
 				inFile >> loadWeight;
 				inFile >> height;
 				inFile >> maxSpeed;
			    Lektuvas* skraidApar = new Lektuvas
					(name, weightOfAparatus, weightOfPasenger, loadWeight, height, maxSpeed);
				skraidAparList.push_back(skraidApar);
				inFile >> name;
     }
    inFile.close();
	//-----------------------
	ifstream inFiles ("baloon.txt");
    inFiles >> name;
    while (inFiles.good())
    {			inFiles >> weightOfAparatus;
 				inFiles >> weightOfPasenger;
 				inFiles >> loadWeight;
 				inFiles >> height;
 				inFiles >> maxSpeed;
			    OroBalionas* skraidApar = new OroBalionas
					(name, weightOfAparatus, weightOfPasenger, loadWeight, height, maxSpeed);
				skraidAparList.push_back(skraidApar);
			    inFiles >> name;
     }    
    inFiles.close();
	//-----------------------	
	ifstream inFilea ("helicopter.txt");
	inFilea >> name;
    while (inFilea.good())
    {           inFilea >> weightOfAparatus;
 				inFilea >> weightOfPasenger;
 				inFilea >> loadWeight;
 				inFilea >> height;
 				inFilea >> maxSpeed;
                Malunsparnis* skraidApar = new Malunsparnis
                    (name, weightOfAparatus, weightOfPasenger, loadWeight, height, maxSpeed);
				skraidAparList.push_back(skraidApar);
				inFilea >> name;
    }
    inFilea.close();			   
//***********************************************	
	skraidAparList.sort(SkraidAparNameCompare()); //surusiuoja pagal abc visus list esancius pavadinimus
	


	string key;
	for (;;)
	{
   	cout << "    ............................................"  << endl
		<< "    :   SKRAIDYMO APARATAI                     :"  << endl
		<< "    ............................................"  << endl
		<< "    :1: - Skraidymo aparatu sarasas            :"  << endl
		<< "    :2: - Kordinuoti pasirinkto aparato skrydi :"  << endl
		<< "    :3: - Kurti naujus skaraidymo paratus      :"  << endl
	        << "    :4: - Skraidymo aparato charakteristika    :"  << endl
		<< "    :0: - Baigti darba                         :"  << endl
		<< "    ............................................"  << endl;
        cout<< "    Pasirinkite komanda: ";
	    cin >> key; 
	    cout << endl;
	         if (key == "1") printSkraidAparList(skraidAparList);
    	else if (key == "2") skrydis(skraidAparList);
        else if (key == "3") newSkraidApar(skraidAparList); 
        else if (key == "4") printAparatuDetails (skraidAparList) ;
        else if (key == "0") // end of program
        {

	
        	SkraidAparList::iterator skraidAparIt = skraidAparList.begin();
            for (; skraidAparIt != skraidAparList.end(); skraidAparIt++)
                delete (*skraidAparIt);    

        	return 0;
        }         
	    else cout << endl << "Neteisinga komanda.." << endl;   
	} 	
} // end of main()

//****************************************************
void printSkraidAparList(SkraidAparList& skraidAparList)
{    cout << "   _____________________________________" << endl;
     cout << "     Skraidymo apratu sarasas  : " << endl;
     cout << "   _____________________________________" << endl;
    SkraidAparList::iterator iter = skraidAparList.begin();
    for (;  iter != skraidAparList.end();  iter++)
	{
     	    cout << "    " << (*iter)-> getName() << endl;
	}
    cout << "   _____________________________________" << endl;   
    cout << endl;    
}
//-----------------------------------------------------------------
SkraidApar* selectSkraidApar (SkraidAparList& skraidAparList)
{
   for (;;)
	{
		string name;
        printSkraidAparList(skraidAparList);
        cout << endl << "   Pasirinkite skraidymo aparata < baigti  - '*'> :  "; 
        cin >> name;
	    if (name == "*"){
            return 0;
        }              	
        SkraidAparList::iterator iter = skraidAparList.begin();
        for (;  iter != skraidAparList.end();  iter++)
           if (name == (*iter)->getName())
			   return *iter;
     }		
    return 0; // unreacheable
}
//-----------------------------------------------------------------
void skrydis(SkraidAparList& skraidAparList)
{
    string name;
    int    vejoGreitis;
    double kuroKiekis;

    cout << endl;
    cout << "   **** Skrydzio Modeliavimas: **** " << endl 
         << "   Iveskite vejo greiti (km/h): ";
    cin >> vejoGreitis;
    cout << "   Iveskite kuro kieki (kg): ";
    cin >> kuroKiekis;

    for (;;){ 

       SkraidApar* skraidApar = selectSkraidApar(skraidAparList);
       if (skraidApar == 0) break;

       int    p = skraidApar->getloadWeight()+ skraidApar->getweightOfPasenger()
                      + skraidApar->getweightOfAparatus();

       double f = (skraidApar-> getMaxSpeed()+ vejoGreitis);   
  
       if (p>0 && p< 1000){
            p=15; 
	    kuroKiekis=kuroKiekis/10;
            cout  << "     Su siais parametrais "<< skraidApar->getName() << " skris : " 
	          << (f * kuroKiekis - p) << " km " << " ir uztruks " 
                  << (f/(skraidApar-> getMaxSpeed()+ 0.02*vejoGreitis)) << " h" << endl;

       } else if (p< 100000){
            p=50; 
	    kuroKiekis=kuroKiekis;
            cout << "    Su siais parametrais "<< skraidApar->getName() << " skris:  " 
	    << (f * kuroKiekis - p) << " km " << " ir uztruks " 
            << (f/(skraidApar-> getMaxSpeed()+ 1.2*vejoGreitis)) << " h" << endl;

       } else if (p>99999){
            p=150; 
	    kuroKiekis=kuroKiekis;
            cout << "    Su siais parametrais " << skraidApar->getName() << " skris: "
	    <<(f * kuroKiekis - p) << " km " << " ir uztruks " 
            <<(f/(skraidApar-> getMaxSpeed()+ 1.3*vejoGreitis)) << " h" << endl;
     
       } else if (p<0) {
            cout << " svoris negali buti neigiamas" << endl;
	    }
          
   }
}

//--------------------------------
void newSkraidApar(SkraidAparList& skraidAparList){
 int i=7;
	string  name;
 	int weightOfAparatus;
 	int weightOfPasenger;
 	int loadWeight;
 	int height;
 	int maxSpeed;
 	for (;;){
 	  if (i==0) break;
 	     cout << "    ______________________________________________" << endl
 	          << "        Naujo aparato sukurimas :                      " << endl;
 	     cout << "    ______________________________________________" << endl;
         cout << "     Jei norite sukurti lektuva     - 1" << endl
              << "     Jei norite sukurti oro baliona - 2" << endl
              << "     Jei norite sukurti malunsparni - 3" << endl 
              << "     Iseiti is sio pasirinkimo      - 0" << endl;
         cout << "    ______________________________________________" << endl;
         cout << "     Jusu pasirinkimas :" ; cin >> i; cout << endl;
      if (i==1){
        cout << "      Skraidymo aparato pavadinimas :" << endl;
        cin >> name;
        cout << "      Skraidymo aparato svoris (kg):" << endl;
        cin >> weightOfAparatus;
        cout << "      Skraidymo aparato keleiviu svoris (kg):" << endl;
        cin >> weightOfPasenger;
        cout << "      Skraidymo aparato krovinio svoris (kg): " << endl;
        cin >> loadWeight;
        cout << "      Skaraidymo aparati max pakilimo aukstis (m): " << endl;
        cin >> height;
        cout << "      Skaraidymo aparati max greitis (km/h): "<< endl; 
        cin >> maxSpeed;
				skraidAparList.push_back(new Lektuvas
					(name, weightOfAparatus, weightOfPasenger, loadWeight, height, maxSpeed));
				
        ofstream outFile("plane.txt", ios:: app);
        outFile <<	name << " " <<weightOfAparatus << " " << weightOfPasenger
                << " " << loadWeight << " " << height << " " << maxSpeed << endl;
        outFile.close();
   
	 } else if (i==2){	   
             cout << "      Skraidymo aparato pavadinimas :" << endl;
             cin >> name;
             cout << "      Skraidymo aparato svoris (kg):" << endl;
             cin >> weightOfAparatus;
             cout << "      Skraidymo aparato keleiviu svoris (kg):" << endl;
             cin >> weightOfPasenger;
             cout << "      Skraidymo aparato krovinio svoris (kg): " << endl;
             cin >> loadWeight;
             cout << "      Skaraidymo aparati max pakilimo aukstis (m): " << endl;
             cin >> height;
             cout << "      Skaraidymo aparati max greitis: "<< endl;
             cin >> maxSpeed;
				skraidAparList.push_back(new OroBalionas
					(name, weightOfAparatus, weightOfPasenger, loadWeight, height, maxSpeed));
			ofstream outFiles("baloon.txt", ios:: app); //(append) Seek to the end of the stream before each output operation.
            outFiles <<	name << " " << weightOfAparatus << " " << weightOfPasenger
                     << " " << loadWeight << " " << height << " " << maxSpeed << endl;//i faila irasymas
            outFiles.close();
           }
        else if (i==3){ 
                 cout << "      Skraidymo aparato pavadinimas :" << endl;
                 cin >> name;
                 cout << "      Skraidymo aparato svoris (kg):" << endl;
                 cin >> weightOfAparatus;
                 cout << "      Skraidymo aparato keleiviu svoris (kg):" << endl;
                 cin >> weightOfPasenger;
                 cout << "      Skraidymo aparato krovinio svoris (kg): " << endl;
                 cin >> loadWeight;
                 cout << "      Skaraidymo aparati max pakilimo aukstis (m): " << endl;
                 cin >> height;
                 cout << "      Skaraidymo aparati max greitis: "<< endl;
                 cin >> maxSpeed;
    	         skraidAparList.push_back(new Malunsparnis
                     (name, weightOfAparatus, weightOfPasenger, loadWeight, height, maxSpeed));
                 ofstream outFilea("helicopter.txt", ios:: app);    //(append) Seek to the end of the stream before each output operation.
                 outFilea << name << " " << weightOfAparatus << " " << weightOfPasenger 
                          << " " << loadWeight << " " << height << " " << maxSpeed << endl;//i faila irasymas
                outFilea.close();
             }
			
            if (i==0) break;
    }    //for 
}    
//-----------
void printAparatuDetails (SkraidAparList& skraidAparList) 
{  
    for (;;){        
      
    SkraidApar* skraidApar= selectSkraidApar(skraidAparList); 
    if (skraidApar == 0) break;
    cout << "      __________________________________________________________" << endl;
    cout << "          Aparato charakteristika: "               << endl; 
    cout << "      __________________________________________________________" << endl;
    skraidApar->print();  
    cout << "      __________________________________________________________" << endl;
    }
}    
