#include <iostream>
#include <string>
#include <cmath>
#include "skraidApar.h"

using namespace std;

SkraidApar::SkraidApar (const string& name, int weightOfAparatus, int weightOfPasenger,
                    int loadWeight, int height , int maxSpeed)
 : name (name),
   weightOfAparatus (weightOfAparatus),
   weightOfPasenger (weightOfPasenger),
   loadWeight       (loadWeight),
   height           (height),
   maxSpeed         (maxSpeed)
  
{}

//-----------------------------------------------------------------
SkraidApar::SkraidApar (const SkraidApar& skraidApar) // for cloning
 : name (skraidApar.name),
   weightOfAparatus (skraidApar.weightOfAparatus),
   weightOfPasenger (skraidApar.weightOfPasenger),
   loadWeight       (skraidApar.loadWeight),
   height           (skraidApar.height),
   maxSpeed         (skraidApar.maxSpeed)
{}

//-----------------------------------------------------------------
SkraidApar::~SkraidApar ()
{}  

//------------------------------ 
void SkraidApar::print (const string& margin) const
{
cout << "          " << margin << endl
     << "      Skraidymo aparato pavadinimas :          " << name                  << endl 
     << "      Skraidymo aprato  svoris (kg) :          " << weightOfAparatus << endl
     << "      Skraidymo aparato keleiviu svoris (kg) : " << weightOfPasenger << endl
     << "      Skraidymo aparato krovinio svoris (kg):  " << loadWeight      << endl
     << "      Skraidymo aparato max aukstis (m) :      " << height          << endl
     << "      Skraidymo aparato max greitis (km/h) :   " << maxSpeed        << endl;
}
//---------------------------------------------------------------//
//                                                               //
//   Lektuvas                                                   //
//   =========                                                   //
//                                                               //
//---------------------------------------------------------------//
Lektuvas::Lektuvas (const string& name,	int weightOfAparatus, int weightOfPasenger,
                    int loadWeight, int height , int maxSpeed )

  : SkraidApar(name, weightOfAparatus, weightOfPasenger, loadWeight, height, maxSpeed)
{}
//---------------------------------------------------------------//
//                                                               //
//   OroBalionas                                              //
//   ==============                                              //
//                                                               //
//---------------------------------------------------------------//
OroBalionas::OroBalionas (const string& name, int  weightOfAparatus, int weightOfPasenger,
	                      int loadWeight, int height , int maxSpeed )


  : SkraidApar(name, weightOfAparatus, weightOfPasenger, loadWeight, height, maxSpeed)
   {}
//---------------------------------------------------------------//
//                                                               //
//   Malunsparnis                                              //
//   ==============                                              //
//                                                               //
//---------------------------------------------------------------//
Malunsparnis::Malunsparnis (const string& name, int  weightOfAparatus, int weightOfPasenger,
	                        int loadWeight, int height , int maxSpeed )

  : SkraidApar(name, weightOfAparatus, weightOfPasenger, loadWeight, height, maxSpeed)
{}
