#ifndef __skraidApar_h
#define __skraidApar_h
#include <string>

//-----------------------------------------------------------------
class SkraidApar
{
protected:
        std::string name;
	int weightOfAparatus;
	int weightOfPasenger;   
	int loadWeight;
	int height;
	int maxSpeed;
public:
        SkraidApar (const std::string& name, int weightOfAparatus, int weightOfPasenger,
                    int loadWeight, int height , int maxSpeed);
        SkraidApar (const SkraidApar& skraidApar); // for cloning 
        ~SkraidApar ();
        virtual void print (const std::string& margin = "") const; 
        virtual	 int getweightOfAparatus    () const = 0;
        virtual	 int getweightOfPasenger    () const = 0;
        virtual  int getloadWeight          () const = 0;
        virtual  int getHeight              () const = 0;
        virtual  int getMaxSpeed            () const = 0;
        std::string  getName                () const {return name;}
};
//---------------------------
class Lektuvas : public SkraidApar
{
/*protected:
	int weightOfAparatus;
	int weightOfPasenger;   
	int loadWeight;
	int height;
	int maxSpeed;*/
public:
	Lektuvas (const std::string& name, int weightOfAparatus, int weightOfPasenger,
              int loadWeight, int height , int maxSpeed );

	int getweightOfAparatus    () const {return weightOfAparatus;}
	int getweightOfPasenger    () const {return weightOfPasenger;}
	int getloadWeight          () const {return loadWeight;}
	int getHeight              () const {return height;}
	int getMaxSpeed            () const {return maxSpeed;}
};
//-----------------------------------------------------------------
class OroBalionas : public SkraidApar
{
/*protected:    
    int weightOfAparatus;
    int weightOfPasenger;   
    int loadWeight;
    int height;
    int maxSpeed;*/
public:
	OroBalionas (const std::string& name, int weightOfAparatus, int weightOfPasenger,
                 int loadWeight, int height , int maxSpeed );

    int getweightOfAparatus    () const {return weightOfAparatus;}
    int getweightOfPasenger    () const {return weightOfPasenger;}
    int getloadWeight          () const {return loadWeight;}
    int getHeight              () const {return height;}
    int getMaxSpeed            () const {return maxSpeed;}
};
//-----------------------------------------------------------------
class Malunsparnis : public SkraidApar
{
/*protected:    
    int weightOfAparatus;
    int weightOfPasenger;   
    int loadWeight;
    int height;
    int maxSpeed;*/
public:
	Malunsparnis (const std::string& name, int weightOfAparatus, int weightOfPasenger,
                  int loadWeight, int height , int maxSpeed ); 

    int getweightOfAparatus    () const {return weightOfAparatus;}
    int getweightOfPasenger    () const {return weightOfPasenger;}
    int getloadWeight          () const {return loadWeight;}
    int getHeight              () const {return height;}
    int getMaxSpeed            () const {return maxSpeed;}
};
//---------------------------------------------------------------
class SkraidAparNameCompare
{
public:
    bool operator() (const SkraidApar* a, const SkraidApar* b) const
    {
       return (a->getName() < b->getName());
    }    
};
#endif // __skraidApar_h*/

